/**
 * 拡張機能の設定
 * Tooltip機能を使用する場合は:trueに設定 
 * @type {{Tooltip: boolean}}
 */
const ValExtOption = {
  Tooltip:true
}

/**
 * Valence 追加する機能を設定したValExtOption
 * @class ValExt
 * @constructor
 * @classdesc 拡張用ベースクラス
 * @param {object} ValExtOption
 */
export class ValExt{  
  _initialize = false;
  _option = null;

  /**
   * コンストラクタ
   */  
  constructor(option){
    this._option = option;
  }

  /**
   * 拡張機能を同期読込するための　非同期メソッド
   * 機能を有効化する際に実行
   * @method load
   */
  async load(){
    if(! this._initialize){
      this._initialize = true;
      // Tooltip機能使用チェック
      if (this._option.Tooltip){
        // Tooltipを使用する場合は動的に読込む
        const module = await import("./ValExt.Tooltip.js");
        this.Tooltip = new module.default();   
        this.Tooltip.setOwner(this); 
        this.Tooltip.dataView = Ext.ComponentQuery.query('launchpad')[0].down('dataview');
        this.Tooltip.observeStart(Ext.ComponentQuery.query('launchpad')[0].el.dom);   
      }
    }
  }  
}

/**
 * ValExtオブジェクト作成
 */
function ValExt_main(){
  window.ValExt = new ValExt(ValExtOption);
}
// ValExtオブジェクト作成呼び出し
ValExt_main();

